package com.zy.servicebase.handler;

import com.zy.commonutils.R;
import com.zy.commonutils.exception.ExceptionUtil;
import com.zy.commonutils.exception.FileException;
import com.zy.commonutils.exception.GuliException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * @author zhangyu
 */
@Slf4j
@ControllerAdvice
public class GlobalExceptionHandler {

    /**
     * 处理文件上传 及 下载异常
     * @param e 异常
     * @return 返回异常数据
     */
    @ExceptionHandler(FileException.class)
    @ResponseBody
    public R error(FileException e){
        e.printStackTrace();
        return R.error().message("文件上传失败！！！");
    }

    /**
     * 自定义的异常处理
     * @param e 异常
     * @return 返回数据
     */
    @ExceptionHandler(GuliException.class)
    @ResponseBody
    public R error(GuliException e){
        log.error(ExceptionUtil.getMessage(e));
        e.printStackTrace();
        return R.error().code(e.getCode()).message(e.getMsg());
    }

}
