package com.zy.eduservice.controller;


import com.zy.commonutils.R;
import com.zy.eduservice.client.VodClient;
import com.zy.eduservice.entity.EduVideo;
import com.zy.eduservice.service.EduVideoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

/**
 * <p>
 * 课程视频 前端控制器
 * </p>
 *
 * @author zyGardenia
 * @since 2022-03-19
 */
@RestController
@RequestMapping("/eduservice/video")
public class EduVideoController {
    @Autowired
    private EduVideoService eduVideoService;

    @Autowired
    private VodClient vodClient;

    //添加小节
    @PostMapping("addVideo")
    public R addVideo(@RequestBody EduVideo eduVideo) {
        eduVideoService.save(eduVideo);
        return R.ok();
    }

    /**
     * 刪除视频
     */
    @DeleteMapping("{id}")
    public R deleteVideo(@PathVariable String id) {
        // 此 id 为 数据库 video 的 id 主键字段
        eduVideoService.removeById(id);
        return vodClient.removeVideo(id);
    }

    /**
     * 删除小节同时把小节中的视频删除
     */
    @DeleteMapping("/chapter/{id}")
    public R deleteChapter(@PathVariable String id) {
        //根据小节 id 查询出视频id，进行删除
        EduVideo eduVideobyId = eduVideoService.getById(id);
        String videoSourceId = eduVideobyId.getVideoSourceId();
        //判断是否有视频,有就删除
        if (!StringUtils.isEmpty(videoSourceId)) {
            //远程调用vod删除视频
            vodClient.removeVideo(videoSourceId);
        }
        //删除小节
        eduVideoService.removeById(id);
        return R.ok();
    }
}

