package com.zy.eduorder.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zy.commonutils.R;
import com.zy.eduorder.entity.Order;
import com.zy.eduorder.service.OrderService;
import com.zy.eduorder.service.PayLogService;
import com.zy.servicebase.utils.JwtUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

/**
 * <p>
 * 支付日志表 前端控制器
 * </p>
 *
 * @author zyGardenia
 * @since 2022-03-22
 */
@RestController
@RequestMapping("/eduorder/pay-log")
public class PayLogController {
    @Autowired
    private PayLogService payLogService;

    /**
     * 生成微信支付二维码
     */
    @GetMapping("createNative/{orderNo}")
    public R createNative(@PathVariable String orderNo){
        //返回信息，包含二维码地址，还有其他需要的信息
        Map<String, Object> map = payLogService.createNative(orderNo);
        return R.ok().data(map);
    }

    /**
     *   查询订单支付状态
     */
    @GetMapping("queryPayStatus/{orderNo}")
    public R queryPayStatus(@PathVariable String orderNo){
        // 返回信息，包含二维码地址，还有其他需要的信息
        Map<String,String> map = payLogService.queryPayStatus(orderNo);
        if (map == null){
            return R.error().message("支付出错了");
        }
        // 如果不为空，通过map获取订单状态
        if ("SUCCESS".equals(map.get("trade_state"))){
            // 支付成功，更改订单状态
            payLogService.updateOrderStatus(map);
            return R.ok().message("支付成功");
        }
        return R.error().code(25000).message("支付中");
    }
}

