package com.zy.staservice.controller;

import com.zy.commonutils.R;
import com.zy.staservice.service.DailyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * <p>
 * 网站统计日数据 前端控制器
 * </p>
 *
 * @author zyGardenia
 * @since 2022-03-23
 */
@RestController
@RequestMapping("/staservice/daily")
public class DailyController {
    @Autowired
    private DailyService dailyService;

    /**
     * 统计一天的注册人数,生成统计数据
     */
    @PostMapping("registerCount/{day}")
    public R registerCount(@PathVariable String day){
        dailyService.countRegister(day);
        return R.ok();
    }

    @GetMapping("getShowData/{type}/{begin}/{end}")
    public R getShowData(@PathVariable String type,@PathVariable String begin,@PathVariable String end){
        Map<String,Object> map = dailyService.getShowData(type,begin,end);
        return R.ok().data(map);
    }
}

