package com.zy.cmsservice.service.impl;

import com.zy.cmsservice.entity.QQEmailMsg;
import com.zy.cmsservice.service.EmailService;
import com.zy.cmsservice.utils.VerCodeGenerateUtil;
import com.zy.commonutils.R;
import com.zy.commonutils.exception.GuliException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import javax.annotation.Resource;
import java.time.Duration;
import java.util.concurrent.TimeUnit;

/**
 * @author 张雨 - 栀
 * @version 1.0
 * @Since 2022/3/22 12:35
 */
@Service
public class EmailServiceImpl implements EmailService {
    @Resource
    private JavaMailSender mailSender;

    // 艹蛋 了，刚刚可以注入，这又不行了，啥也没改！真佛性，坐着可以，跪着就不行了 。。。 解决了 看POM的最后 build ！！！
    @Value("${spring.mail.username}")
    private String sendUsername;

    @Autowired
    private RedisTemplate<String, String> redisTemplate;

    @Override
    public R sendEmail(QQEmailMsg qqEmailMsg) {
        // 查询 redis key
        String code = redisTemplate.opsForValue().get(qqEmailMsg.getTos()[0]);
        if(!StringUtils.isEmpty(code)){
            return R.ok();
        }
        //  创建邮件消息
        SimpleMailMessage message = new SimpleMailMessage();
        message.setFrom(sendUsername);
        message.setTo(qqEmailMsg.getTos());
        message.setSubject("您本次的验证码是");
        // 生成随机验证码
        String verCode = VerCodeGenerateUtil.generateVerCode();
        message.setText("尊敬的xxx,您好:\n"
                + "\n本次请求的邮件验证码为:" + verCode + ",本验证码 永久(5 分钟内)有效，请及时输入。（开玩笑的！请勿泄露此验证码）\n"
                + "\n如非本人操作，请忽略该邮件。\n(这是一封通过自动发送的邮件，请不要直接回复）");
        try{
            mailSender.send(message);
            redisTemplate.opsForValue().set(qqEmailMsg.getTos()[0], verCode, 5, TimeUnit.MINUTES);
        }catch (Exception e){
            return R.error().message("发送失败！");
        }
//        SysUser user = Context.getUser(request.getHeader("token"));
//        user.setVerCode(verCode);
        return R.ok().message("发送成功!");
    }
}
