package com.zy.ossservice.controller;

import com.zy.commonutils.R;
import com.zy.ossservice.service.FileSolveService;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * @author 张雨 - 栀
 * @version 1.0
 * @create 2022/3/19 20:15
 */
@RestController
@RequestMapping("/fileoss/upload")
public class FileSolveController {
    @Autowired
    private FileSolveService fileSolveService;

    @PostMapping("img")
    public R uploadImgFile(MultipartFile file) {
        //返回上传 本地oss 的url
        String url = fileSolveService.saveImgs(file);
        return R.ok().data("url", url);
    }

    @PostMapping("mp4")
    public R uploadMp4File(MultipartFile file) {
        //返回上传 本地oss 的url
        String url = fileSolveService.saveMp4(file);
        return R.ok().data("VideoSourceUrl", url);
    }

    @DeleteMapping("{videoId}")
    public R removeVideo(@ApiParam(name = "videoId", value = "云端视频id", required = true)
                         @PathVariable String videoId) {
        return R.ok().message("视频删除成功！");
    }

    /**
     * 删除多个阿里云视频
     */
    @DeleteMapping("deleteBatch")
    public R deleteBatch(@RequestParam List<String> videoIdList) {
        return R.ok();
    }

    /**
     * 根据视频 id 获得视频凭证
     */
    @GetMapping("getPlayAuth/{id}")
    public R getPlayAuth(@PathVariable String id) {
        return R.ok().data("playAuth", id);
    }
}
